//+------------------------------------------------------------------+
//|                                                 WAPLogChart.mq4 |
//|                            Copyright 2007-2017, FinanceWave.com |
//|                              http://www.facebook.com/FinanceWave |
//|                                                     @FinanceWave |
//|                                       http://www.financewave.com |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2007-2017, FinanceWave.com"
#property link        "http://www.financewave.com"
#property description "WAPLogChart"

#property indicator_separate_window
#property indicator_buffers 21
#property indicator_color13 White
#property indicator_color14 White
#property indicator_color15 White
#property indicator_color16 White
#property indicator_color17 Gold
#property indicator_color18 White
#property indicator_color19 White
#property indicator_color20 White
#property indicator_color21 White

extern color  Up   = C'0,128,0';
extern color  Down   = C'255,0,0';
extern color  Doji   = C'255,255,0';

color bg;
//--- indicator buffers
double         GREEN_HIGH[];
double         GREEN_OPEN[];
double         GREEN_CLOSE[];
double         GREEN_LOW[];
double         RED_HIGH[];
double         RED_OPEN[];
double         RED_CLOSE[];
double         RED_LOW[];
double         YELLOW_HIGH[];
double         YELLOW_OPEN[];
double         YELLOW_CLOSE[];
double         YELLOW_LOW[];

extern int ibars = 1440;

double e;
double WAPm;
double countWAPm;

int begin=60;
int finish=1440;

double wapHrec=0;
double wapLrec=100000;
double wapH2rec=0;
double wapL2rec=100000;
double wapH3rec=0;
double wapL3rec=100000;
double wapH4rec=0;
double wapL4rec=100000;

double price = 0;

double WAPH4[];
double WAPH3[];
double WAPH2[];
double WAPH1[];
double WAP[];
double WAPL1[];
double WAPL2[];
double WAPL3[];
double WAPL4[];

double wapH;
double wapL;
double wapH2;
double wapL2;
double wapH3;
double wapL3;
double wapH4;
double wapL4;
double wap;
double count;
double sum;
double sumE;

int i;
int n;
int j;
datetime TimeBar = Time[0];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   IndicatorShortName("WapLogChart");

   bg=(color)ChartGetInteger(ChartID(),CHART_COLOR_BACKGROUND);
//--- indicator buffers mapping
   SetIndexBuffer(0,GREEN_CLOSE);SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,3,Up);
   SetIndexBuffer(1,GREEN_OPEN);SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,3,bg);
   SetIndexBuffer(2,GREEN_HIGH);SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,1,Up);
   SetIndexBuffer(3,GREEN_LOW);SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,1,bg);
   SetIndexBuffer(4,RED_OPEN);SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID,3,Down);
   SetIndexBuffer(5,RED_CLOSE);SetIndexStyle(5,DRAW_HISTOGRAM,STYLE_SOLID,3,bg);
   SetIndexBuffer(6,RED_HIGH);SetIndexStyle(6,DRAW_HISTOGRAM,STYLE_SOLID,1,Down);
   SetIndexBuffer(7,RED_LOW);SetIndexStyle(7,DRAW_HISTOGRAM,STYLE_SOLID,1,bg);
   SetIndexBuffer(8,YELLOW_OPEN);SetIndexStyle(8,DRAW_HISTOGRAM,STYLE_SOLID,3,Doji);
   SetIndexBuffer(9,YELLOW_CLOSE);SetIndexStyle(9,DRAW_HISTOGRAM,STYLE_SOLID,3,bg);
   SetIndexBuffer(10,YELLOW_HIGH);SetIndexStyle(10,DRAW_HISTOGRAM,STYLE_SOLID,1,Doji);
   SetIndexBuffer(11,YELLOW_LOW);SetIndexStyle(11,DRAW_HISTOGRAM,STYLE_SOLID,1,bg);
   
   SetIndexBuffer(12,WAPH4);
   SetIndexBuffer(13,WAPH3);
   SetIndexBuffer(14,WAPH2);
   SetIndexBuffer(15,WAPH1);
   SetIndexBuffer(16,WAP);
   SetIndexBuffer(17,WAPL1);
   SetIndexBuffer(18,WAPL2);
   SetIndexBuffer(19,WAPL3);
   SetIndexBuffer(20,WAPL4);
   SetIndexStyle(12,DRAW_ARROW);SetIndexArrow(12,158);
   SetIndexStyle(13,DRAW_ARROW);SetIndexArrow(13,158);
   SetIndexStyle(14,DRAW_ARROW);SetIndexArrow(14,158);
   SetIndexStyle(15,DRAW_ARROW);SetIndexArrow(15,158);
   SetIndexStyle(16,DRAW_ARROW);SetIndexArrow(16,158);
   SetIndexStyle(17,DRAW_ARROW);SetIndexArrow(17,158);
   SetIndexStyle(18,DRAW_ARROW);SetIndexArrow(18,158);
   SetIndexStyle(19,DRAW_ARROW);SetIndexArrow(19,158);
   SetIndexStyle(20,DRAW_ARROW);SetIndexArrow(20,158);

   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);   
   SetIndexLabel(3,NULL);      
   SetIndexLabel(4,NULL);      
   SetIndexLabel(5,NULL);      
   SetIndexLabel(6,NULL);      
   SetIndexLabel(7,NULL);      
   SetIndexLabel(8,NULL);      
   SetIndexLabel(9,NULL);      
   SetIndexLabel(10,NULL);      
   SetIndexLabel(11,NULL);      
   SetIndexLabel(12,NULL);      
   SetIndexLabel(13,NULL);      
   SetIndexLabel(14,NULL);      
   SetIndexLabel(15,NULL);      
   SetIndexLabel(16,NULL);      
   SetIndexLabel(17,NULL);      
   SetIndexLabel(18,NULL);      
   SetIndexLabel(19,NULL);      
   SetIndexLabel(20,NULL);      

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
   int start()

  {
   double OPEN,HIGH,LOW,CLOSE;

   for(i=Bars-1;i>=0;i--) 
   {
      GREEN_OPEN[i]=GREEN_HIGH[i]=GREEN_LOW[i]=GREEN_CLOSE[i]=EMPTY_VALUE;
      RED_OPEN[i]=RED_HIGH[i]=RED_LOW[i]=RED_CLOSE[i]=EMPTY_VALUE;
      YELLOW_OPEN[i]=YELLOW_HIGH[i]=YELLOW_LOW[i]=YELLOW_CLOSE[i]=EMPTY_VALUE;
   }

   for(i=Bars-1;i>=0;i--) 
   {
     {

      OPEN=MathLog(iOpen(NULL,0,i));
      CLOSE=MathLog(iClose(NULL,0,i));
      HIGH=MathLog(iHigh(NULL,0,i));
      LOW=MathLog(iLow(NULL,0,i));

      if(CLOSE>OPEN)
         {
         GREEN_OPEN[i]=OPEN;
         GREEN_HIGH[i]=HIGH;
         GREEN_LOW[i]=LOW;
         GREEN_CLOSE[i]=CLOSE;
         }
      else if(CLOSE<OPEN) 
        {
         RED_OPEN[i]=OPEN;
         RED_HIGH[i]=HIGH;
         RED_LOW[i]=LOW;
         RED_CLOSE[i]=CLOSE;
        }
      else if(CLOSE==OPEN)
        {YELLOW_OPEN[i]=OPEN;
         YELLOW_HIGH[i]=HIGH;
         YELLOW_LOW[i]=LOW;
         YELLOW_CLOSE[i]=CLOSE;
        }
      }
   }

if(Bars-1>=1440)
{

for(i=MathMin(ibars,Bars-1-1440); i>=0; i--)
{
wapHrec=0;
wapLrec=1000000;
wapH2rec=0;
wapL2rec=1000000;
wapH3rec=0;
wapL3rec=1000000;
wapH4rec=0;
wapL4rec=1000000;
WAPm=0;
countWAPm=0;

for(n = begin; n<=finish; n++)
{
for(j = n-1; j>=0; j--)
{
price=(MathLog(High[i+j])+MathLog(Close[i+j])+MathLog(Low[i+j])+MathLog(Open[i+j]))/4;

if(j==n-1)
{
sum=price;
count=1;
wap=sum/count;

sumE=MathMax(price-wap,wap-price);
e=sumE/count;

wapH=wap+e;
wapL=wap-e;
wapH2=wap+2*e;
wapL2=wap-2*e;
wapH3=wap+3*e;
wapL3=wap-3*e;
wapH4=wap+4*e;
wapL4=wap-4*e;
}
else
{
sum=sum+price;
count=count+1;
wap=sum/count;

sumE=sumE+MathMax(price-wap,wap-price);
e=sumE/count;

wapH=wap+e;
wapL=wap-e;
wapH2=wap+2*e;
wapL2=wap-2*e;
wapH3=wap+3*e;
wapL3=wap-3*e;
wapH4=wap+4*e;
wapL4=wap-4*e;
}
}

if(wapH>wapHrec)
{wapHrec=wapH;}
if(wapL<wapLrec)
{wapLrec=wapL;}

if(wapH2>wapH2rec)
{wapH2rec=wapH2;}
if(wapL2<wapL2rec)
{wapL2rec=wapL2;}

if(wapH3>wapH3rec)
{wapH3rec=wapH3;}
if(wapL3<wapL3rec)
{wapL3rec=wapL3;}

if(wapH4>wapH4rec)
{wapH4rec=wapH4;}
if(wapL4<wapL4rec)
{wapL4rec=wapL4;}

WAPm=WAPm+wap;
countWAPm=countWAPm+1;
}

WAPm=WAPm/countWAPm;

WAP[i]=WAPm;
WAPH1[i]=wapHrec;
WAPH2[i]=wapH2rec;
WAPH3[i]=wapH3rec;
WAPH4[i]=wapH4rec;
WAPL1[i]=wapLrec;
WAPL2[i]=wapL2rec;
WAPL3[i]=wapL3rec;
WAPL4[i]=wapL4rec;

}
ibars=0;

if(TimeBar!=Time[0])
{
for(j = 1; j<=1500; j++)
{
if( TimeBar==Time[j] )
{ibars=j;
break;}
}
TimeBar=Time[0];
}

}

ObjectCreate( 0,"LINE1",OBJ_HLINE,ChartWindowFind(0,"WapLogChart"),Time[0],MathLog(iClose(NULL,0,0)));
ObjectSet   ("LINE1", OBJPROP_PRICE1,MathLog(iClose(NULL,0,0)) );
ObjectSet   ("LINE1",OBJPROP_COLOR,Gray);
ObjectSet   ("LINE1",OBJPROP_WIDTH,1);

   return(0);
  }
//+------------------------------------------------------------------+